<?php

namespace Teknisa\DF\Modules\Entrada\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;

class GrupoItensAfs extends \Teknisa\DF\Controllers\TeknisaCrud {

    protected $dataSourceName = 'grupo_itens_afs';

    protected $parameterBagColumns = array(
        'CDFILLANC',
        'CDFILDEST',
        'NRAUTOFORN',
        'DTPROGENTAF'
    );

    public function find(DTO\Request\Filter $request, DTO\Response $response) {

        $conditions = $request->getFilterCriteria()->getConditions();
        $grupoItensAfs = array();

        if (count($conditions) > 0) {
            $afs = $conditions[0]['value'];
            foreach ($afs as $af) {
                $defaultParameterBag = array(
                    'operator' => '='
                );

                foreach ($this->parameterBagColumns as $parameter) {
                    $defaultParameterBag['columnName'] = $parameter;
                    $defaultParameterBag['value'] = $af[$parameter];
                    $newConditions[] = $defaultParameterBag;
                }

                $currentGrupoItensAfs = $this->crudService->getFilteredDataSet($this->dataSourceName, $newConditions);
                $rows = $currentGrupoItensAfs->getRows();

                $grupoItensAfs = array_merge($grupoItensAfs, $rows);
            }
        }

        $response->addDataset(new DataSet($this->dataSourceName, $grupoItensAfs));
    }
}