<?php
namespace Teknisa\DF\Modules\Relatorios\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;

class ParamfilialForAdm03000 extends \Teknisa\DF\Controllers\TeknisaCrud {

    protected $dataSourceName = "paramfilial_forAdm03000";
    protected $Adm03000Service;
    protected $parameterBagColumns = array("CDFILIAL");

    public function __construct($crudService, $parameterBag, $Adm03000Service) {
        parent::__construct($crudService, $parameterBag);
        $this->Adm03000Service = $Adm03000Service;
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $requestConditions = $request->getFilterCriteria()->getConditions();
        $filial = $requestConditions[0]["value"];

        parent::find($request, $response);
        $dataSets = $response->getDataSets();
        $rows = $dataSets[0]->getRows();

        if(!empty($rows)){
            $row = $rows[0];
            try {
                $newRow = $this->Adm03000Service->verificaNotaFiscal($row, $filial);
                $rows = array($row, $newRow);
                $dataSet = new DataSet('filial_logada', $rows);
                $response->setDataSets(array($dataSet));
            } catch (\Exception $e) {
                $response->setError(new Error($e->getMessage() , 500));
            }
        } else {
            $response->setDataSets(array());
            $response->setError(new Error('Erro ao encontrar dados da filial selecionada.' , 500));
        }
    }
}